Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::OCB_Mode Class Referenceabstract

`#include <ocb.h>`

Inheritance diagram for Botan::OCB_Mode:

## Public Member Functions
bool | authenticated () const override
void | clear () override
size_t | default_nonce_length () const override
virtual void | finish (secure_vector< uint8_t > &final_block, size_t offset=0)=0
Key_Length_Specification | key_spec () const override
virtual size_t | minimum_final_size () const =0
std::string | name () const override
virtual size_t | output_length (size_t input_length) const =0
virtual size_t | process (uint8_t msg[], size_t msg_len)=0
virtual std::string | provider () const
void | reset () override
template<typename Alloc >
void | set_ad (const std::vector< uint8_t, Alloc > &ad)
void | set_associated_data (const uint8_t ad[], size_t ad_len) override
template<typename Alloc >
void | set_associated_data_vec (const std::vector< uint8_t, Alloc > &ad)
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
template<typename Alloc >
void | start (const std::vector< uint8_t, Alloc > &nonce)
void | start (const uint8_t nonce[], size_t nonce_len)
void | start ()
size_t | tag_size () const override
void | update (secure_vector< uint8_t > &buffer, size_t offset=0)
size_t | update_granularity () const override
bool | valid_keylength (size_t length) const
bool | valid_nonce_length (size_t) const override
| ~OCB_Mode ()

## Protected Member Functions
| OCB_Mode (BlockCipher *cipher, size_t tag_size)

## Protected Attributes
secure_vector< uint8_t > | m_ad_hash
size_t | m_block_index = 0
secure_vector< uint8_t > | m_checksum
std::unique_ptr< BlockCipher > | m_cipher
std::unique_ptr< L_computer > | m_L
secure_vector< uint8_t > | m_offset

## Detailed Description

OCB Mode (base class for OCB_Encryption and OCB_Decryption). Note that OCB is patented, but is freely licensed in some circumstances.

See also
  "The OCB Authenticated-Encryption Algorithm" internet draft http://tools.ietf.org/html/draft-irtf-cfrg-ocb-03
  Free Licenses http://www.cs.ucdavis.edu/~rogaway/ocb/license.htm
  OCB home page http://www.cs.ucdavis.edu/~rogaway/ocb

Definition at line 28 of file ocb.h.

## Constructor & Destructor Documentation

Botan::OCB_Mode::~OCB_Mode | ( |  | ) |

Definition at line 129 of file ocb.cpp.

129 { /* for unique_ptr destructor */ }

Botan::OCB_Mode::OCB_Mode | ( | BlockCipher * | cipher,
|  | size_t | tag_size
| ) |  |
| protected

Parameters

  cipher | the 128-bit block cipher to use
  tag_size | is how big the auth tag will be

Definition at line 115 of file ocb.cpp.

References m_cipher.

115 :
116 m_cipher(cipher),
117 m_checksum(m_cipher->parallel_bytes()),
118 m_offset(16),
119 m_ad_hash(16),
120 m_tag_size(tag_size)
121 {
122 if(m_cipher->block_size() != 16)
123 throw Invalid_Argument("OCB requires 128 bit cipher");
124
125 if(m_tag_size % 4 != 0 || m_tag_size < 8 || m_tag_size > 16)
126 throw Invalid_Argument("Invalid OCB tag length");
127 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56
Botan::OCB_Mode::tag_size
size_t tag_size() const override
Definition: ocb.h:41
Botan::OCB_Mode::m_ad_hash
secure_vector< uint8_t > m_ad_hash
Definition: ocb.h:63
Botan::OCB_Mode::m_checksum
secure_vector< uint8_t > m_checksum
Definition: ocb.h:61
Botan::OCB_Mode::m_offset
secure_vector< uint8_t > m_offset
Definition: ocb.h:62

## Member Function Documentation

bool Botan::AEAD_Mode::authenticated | ( |  | ) | const
| inline override virtual inherited

Returns
  true iff this mode provides authentication as well as confidentiality.

Reimplemented from Botan::Cipher_Mode.

Definition at line 25 of file aead.h.

25 { return true; }

void Botan::OCB_Mode::clear | ( |  | ) |
| override virtual

Zeroise all state See also reset_msg()

Implements Botan::Cipher_Mode.

Definition at line 131 of file ocb.cpp.

References m_cipher, m_L, and reset().

132 {
133 m_cipher->clear();
134 m_L.reset(); // add clear here?
135 reset();
136 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56
Botan::OCB_Mode::reset
void reset() override
Definition: ocb.cpp:138
Botan::OCB_Mode::m_L
std::unique_ptr< L_computer > m_L
Definition: ocb.h:57

size_t Botan::AEAD_Mode::default_nonce_length | ( |  | ) | const
| inline override virtual inherited

Returns
  default AEAD nonce size (a commonly supported value among AEAD modes, and large enough that random collisions are unlikely)

Implements Botan::Cipher_Mode.

Reimplemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, and Botan::CCM_Mode.

Definition at line 75 of file aead.h.

75 { return 12; }

virtual void Botan::Cipher_Mode::finish | ( | secure_vector< uint8_t > & | final_block,
|  | size_t | offset = `0`
| ) |  |
| pure virtual inherited

Complete processing of a message.

Parameters

  final_block | in/out parameter which must be at least minimum_final_size() bytes, and will be set to any final output
  offset | an offset into final_block to begin processing

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::CTS_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::OCB_Decryption, Botan::CCM_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::SIV_Decryption, Botan::CTS_Encryption, Botan::CFB_Decryption, Botan::ChaCha20Poly1305_Decryption, Botan::OCB_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::XTS_Decryption, Botan::EAX_Encryption, Botan::GCM_Encryption, Botan::CBC_Encryption, Botan::CFB_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::XTS_Encryption, and Botan::Stream_Cipher_Mode.

Referenced by botan_cipher_update(), and Botan::TLS::write_record().

Key_Length_Specification Botan::OCB_Mode::key_spec | ( |  | ) | const
| override virtual

Returns
  object describing limits on key size

Implements Botan::Cipher_Mode.

Definition at line 163 of file ocb.cpp.

References m_cipher.

164 {
165 return m_cipher->key_spec();
166 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56

virtual size_t Botan::Cipher_Mode::minimum_final_size | ( |  | ) | const
| pure virtual inherited

Returns
  required minimium size to finalize() - may be any length larger than this.

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::CTS_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::CCM_Decryption, Botan::OCB_Decryption, Botan::SIV_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::CTS_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::ChaCha20Poly1305_Decryption, Botan::OCB_Encryption, Botan::EAX_Encryption, Botan::CBC_Encryption, Botan::GCM_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::Stream_Cipher_Mode, Botan::CFB_Mode, and Botan::XTS_Mode.

Referenced by botan_cipher_update().

std::string Botan::OCB_Mode::name | ( |  | ) | const
| override virtual

Implements Botan::Cipher_Mode.

Definition at line 153 of file ocb.cpp.

References m_cipher.

154 {
155 return m_cipher->name() + "/OCB"; // include tag size
156 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56

virtual size_t Botan::Cipher_Mode::output_length | ( | size_t | input_length | ) | const
| pure virtual inherited

Returns the size of the output if this transform is used to process a message with input_length bytes. Will throw if unable to give a precise answer.

Implemented in Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption, Botan::CBC_Decryption, Botan::CCM_Decryption, Botan::OCB_Decryption, Botan::SIV_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::CTS_Encryption, Botan::CCM_Encryption, Botan::SIV_Encryption, Botan::XTS_Decryption, Botan::OCB_Encryption, Botan::ChaCha20Poly1305_Decryption, Botan::CBC_Encryption, Botan::EAX_Encryption, Botan::GCM_Encryption, Botan::XTS_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::Stream_Cipher_Mode, and Botan::CFB_Mode.

Referenced by Botan::TLS::write_record().

virtual size_t Botan::Cipher_Mode::process | ( | uint8_t | msg[],
|  | size_t | msg_len
| ) |  |
| pure virtual inherited

Process message blocks

Input must be a multiple of update_granularity

Processes msg in place and returns bytes written. Normally this will be either msg_len (indicating the entire message was processed) or for certain AEAD modes zero (indicating that the mode requires the entire message be processed in one pass).

Parameters

  msg | the message to be processed
  msg_len | length of the message in bytes

Implemented in Botan::CBC_Decryption, Botan::OCB_Decryption, Botan::EAX_Decryption, Botan::GCM_Decryption, Botan::CFB_Decryption, Botan::ChaCha20Poly1305_Decryption, Botan::OCB_Encryption, Botan::XTS_Decryption, Botan::EAX_Encryption, Botan::GCM_Encryption, Botan::CBC_Encryption, Botan::CFB_Encryption, Botan::ChaCha20Poly1305_Encryption, Botan::XTS_Encryption, Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, Botan::CCM_Mode, Botan::SIV_Mode, and Botan::Stream_Cipher_Mode.

virtual std::string Botan::Cipher_Mode::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::GCM_Mode.

Definition at line 202 of file cipher_mode.h.

202 { return "base"; }

void Botan::OCB_Mode::reset | ( |  | ) |
| override virtual

Resets just the message specific state and allows encrypting again under the existing key

Implements Botan::Cipher_Mode.

Definition at line 138 of file ocb.cpp.

References m_ad_hash, m_block_index, m_checksum, m_offset, and Botan::zeroise().

Referenced by clear().

139 {
140 m_block_index = 0;
141 zeroise(m_ad_hash);
142 zeroise(m_offset);
143 zeroise(m_checksum);
144 m_last_nonce.clear();
145 m_stretch.clear();
146 }
Botan::OCB_Mode::m_ad_hash
secure_vector< uint8_t > m_ad_hash
Definition: ocb.h:63
Botan::OCB_Mode::m_checksum
secure_vector< uint8_t > m_checksum
Definition: ocb.h:61
Botan::OCB_Mode::m_block_index
size_t m_block_index
Definition: ocb.h:59
Botan::OCB_Mode::m_offset
secure_vector< uint8_t > m_offset
Definition: ocb.h:62
Botan::zeroise
void zeroise(std::vector< T, Alloc > &vec)
Definition: secmem.h:211
template<typename Alloc >

void Botan::AEAD_Mode::set_ad | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 66 of file aead.h.

Referenced by Botan::TLS::write_record().

67 {
68 set_associated_data(ad.data(), ad.size());
69 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0

void Botan::OCB_Mode::set_associated_data | ( | const uint8_t | ad[],
|  | size_t | ad_len
| ) |  |
| override virtual

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

Unless reset by another call, the associated data is kept between messages. Thus, if the AD does not change, calling once (after set_key) is the optimum.

Parameters

  ad | the associated data
  ad_len | length of add in bytes

Implements Botan::AEAD_Mode.

Definition at line 174 of file ocb.cpp.

References BOTAN_ASSERT, m_ad_hash, m_cipher, and m_L.

175 {
176 BOTAN_ASSERT(m_L, "A key was set");
177 m_ad_hash = ocb_hash(*m_L, *m_cipher, ad, ad_len);
178 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::OCB_Mode::m_L
std::unique_ptr< L_computer > m_L
Definition: ocb.h:57
Botan::OCB_Mode::m_ad_hash
secure_vector< uint8_t > m_ad_hash
Definition: ocb.h:63
template<typename Alloc >

void Botan::AEAD_Mode::set_associated_data_vec | ( | const std::vector< uint8_t, Alloc > & | ad | ) |
| inline inherited

Set associated data that is not included in the ciphertext but that should be authenticated. Must be called after set_key and before start.

See set_associated_data().

Parameters

  ad | the associated data

Definition at line 51 of file aead.h.

52 {
53 set_associated_data(ad.data(), ad.size());
54 }
Botan::AEAD_Mode::set_associated_data
virtual void set_associated_data(const uint8_t ad[], size_t ad_len)=0
template<typename Alloc >

void Botan::Cipher_Mode::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 172 of file cipher_mode.h.

Referenced by botan_cipher_set_key().

173 {
174 set_key(key.data(), key.size());
175 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 181 of file cipher_mode.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

182 {
183 set_key(key.begin(), key.length());
184 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material
  length | in bytes of key param

Definition at line 191 of file cipher_mode.h.

192 {
193 if(!valid_keylength(length))
194 throw Invalid_Key_Length(name(), length);
195 key_schedule(key, length);
196 }
Botan::Cipher_Mode::name
virtual std::string name() const =0
Botan::Cipher_Mode::valid_keylength
bool valid_keylength(size_t length) const
Definition: cipher_mode.h:162
template<typename Alloc >

void Botan::Cipher_Mode::start | ( | const std::vector< uint8_t, Alloc > & | nonce | ) |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce

Definition at line 38 of file cipher_mode.h.

Referenced by botan_cipher_start(), and Botan::TLS::write_record().

39 {
40 start_msg(nonce.data(), nonce.size());
41 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( | const uint8_t | nonce[],
|  | size_t | nonce_len
| ) |  |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce
  nonce_len | length of nonce

Definition at line 48 of file cipher_mode.h.

49 {
50 start_msg(nonce, nonce_len);
51 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( |  | ) |
| inline inherited

Begin processing a message.

Definition at line 56 of file cipher_mode.h.

57 {
58 return start_msg(nullptr, 0);
59 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

size_t Botan::OCB_Mode::tag_size | ( |  | ) | const
| inline override virtual

Returns
  the size of the authentication tag used (in bytes)

Reimplemented from Botan::Cipher_Mode.

Definition at line 41 of file ocb.h.

Referenced by Botan::OCB_Encryption::finish(), and Botan::OCB_Decryption::finish().

41 { return m_tag_size; }

void Botan::Cipher_Mode::update | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | offset = `0`
| ) |  |
| inline inherited

Process some data. Input must be in size update_granularity() uint8_t blocks.

Parameters

  buffer | in/out parameter which will possibly be resized
  offset | an offset into blocks to begin processing

Definition at line 81 of file cipher_mode.h.

References BOTAN_ASSERT.

Referenced by botan_cipher_update(), Botan::XTS_Encryption::finish(), Botan::ChaCha20Poly1305_Encryption::finish(), Botan::CBC_Encryption::finish(), Botan::CFB_Encryption::finish(), Botan::EAX_Encryption::finish(), Botan::XTS_Decryption::finish(), Botan::CFB_Decryption::finish(), Botan::CTS_Encryption::finish(), Botan::CBC_Decryption::finish(), Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption::finish(), Botan::CTS_Decryption::finish(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption::finish().

82 {
83 BOTAN_ASSERT(buffer.size() >= offset, "Offset ok");
84 uint8_t* buf = buffer.data() + offset;
85 const size_t buf_size = buffer.size() - offset;
86
87 const size_t written = process(buf, buf_size);
88 buffer.resize(offset + written);
89 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Cipher_Mode::process
virtual size_t process(uint8_t msg[], size_t msg_len)=0

size_t Botan::OCB_Mode::update_granularity | ( |  | ) | const
| override virtual

Returns
  size of required blocks to update

Implements Botan::Cipher_Mode.

Definition at line 158 of file ocb.cpp.

References m_cipher.

159 {
160 return m_cipher->parallel_bytes();
161 }
Botan::OCB_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: ocb.h:56

bool Botan::Cipher_Mode::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 162 of file cipher_mode.h.

163 {
164 return key_spec().valid_keylength(length);
165 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Cipher_Mode::key_spec
virtual Key_Length_Specification key_spec() const =0

bool Botan::OCB_Mode::valid_nonce_length | ( | size_t | nonce_len | ) | const
| override virtual

Returns
  true iff nonce_len is a valid length for the nonce

Implements Botan::Cipher_Mode.

Definition at line 148 of file ocb.cpp.

149 {
150 return (length > 0 && length < m_cipher->block_size());
151 }

## Member Data Documentation

secure_vector<uint8_t> Botan::OCB_Mode::m_ad_hash
| protected

Definition at line 63 of file ocb.h.

Referenced by Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), reset(), and set_associated_data().

size_t Botan::OCB_Mode::m_block_index = 0
| protected

Definition at line 59 of file ocb.h.

Referenced by Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), and reset().

secure_vector<uint8_t> Botan::OCB_Mode::m_checksum
| protected

Definition at line 61 of file ocb.h.

Referenced by Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), and reset().

std::unique_ptr<BlockCipher> Botan::OCB_Mode::m_cipher
| protected

Definition at line 56 of file ocb.h.

Referenced by clear(), Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), key_spec(), name(), OCB_Mode(), set_associated_data(), and update_granularity().

std::unique_ptr<L_computer> Botan::OCB_Mode::m_L
| protected

Definition at line 57 of file ocb.h.

Referenced by clear(), Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), and set_associated_data().

secure_vector<uint8_t> Botan::OCB_Mode::m_offset
| protected

Definition at line 62 of file ocb.h.

Referenced by Botan::OCB_Encryption::finish(), Botan::OCB_Decryption::finish(), and reset().

The documentation for this class was generated from the following files:

- src/lib/modes/aead/ocb/ocb.h
- src/lib/modes/aead/ocb/ocb.cpp